//************************************************************************************
//**  
//**  File name:     C:\Dokumente und Einstellungen\Diki\Desktop\Baldringer Projekte\Baldi-PICs\TestV5\FlowCode-v5\FlowCode-v5.c
//**  Title:         
//**  Description:   
//**  
//**  Generated by:  Flowcode v5.0.0.0
//**  Date:          Monday, January 23, 2012 11:10:39
//**  Licence:       Professional
//**  Registered to: Dirk Baldringer
//**  Licence key:   NV9GZD
//**  
//**  
//**  http://www.matrixmultimedia.com
//**  
//************************************************************************************


#define MX_PIC

#define MX_USES_UINT8 1
#define MX_USES_SINT16 0
#define MX_USES_CHAR 0
#define MX_USES_FLOAT 0
#define MX_USES_SINT32 0
#define MX_USES_BOOL 0
#define MX_USES_UINT16 0
#define MX_USES_UINT32 0
//Definitionen fr Microcontroller
#define P12F675
#define FC_CAL_PIC
#define FC_USEGPIO
#define MX_ADC
#define MX_ADC_TYPE_5
#define MX_ADC_BITS_10
#define MX_EE
#define MX_EE_SIZE 128

//Funktionen
#define MX_CLK_SPEED 19660800
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic.h>
#endif

//Konfigurations-Daten

//Interne Funktionen
#include "C:\Programme\Flowcode\v5\FCD\internals.c"

//Makro-Funktions-Deklarationen
void FCM_INIT();


//Variablen-Deklarationen
MX_UINT8 FCV_EEPROM;
MX_UINT8 FCV_LED1;
MX_UINT8 FCV_SW1;




//SWITCH(0): //Defines:

/**** Macro Substitutions ****
a = Unique Reference
b = Switch Port Letter
c = Switch Pin Number
d = Switch Polarity Control
e = Switch Debounce Delay Value (us)
******************************/

#define Switch_3_SW_PORT		porta
#define Switch_3_SW_TRIS		trisa
#define Switch_3_SW_PIN		3
#define Switch_3_SW_POLE		1
#define Switch_3_SW_DELAY		10 * 1000




//SWITCH(0): //Makro-Funktions-Deklarationen

MX_UINT8 FCD_SWITCH0_ReadState();
void FCD_SWITCH0_WaitUntilHigh();
void FCD_SWITCH0_WaitUntilLow();


//EEPROM(0): //Defines:

/**** Macro Substitutions ****
Component has no substitutions
******************************/

#ifndef MX_EEPROM_REF
	#define MX_EEPROM_REF

	extern MX_UINT8 FC_CAL_EE_Read (MX_UINT16 Address);
	extern void FC_CAL_EE_Write (MX_UINT16 Address, MX_UINT8 Data);

#endif




//EEPROM(0): //Makro-Funktions-Deklarationen

MX_UINT16 FCD_EEPROM0_EEPROMRead(MX_UINT16 addr);
void FCD_EEPROM0_WriteEEPROM(MX_UINT16 addr, MX_UINT16 data);



//SWITCH(0): //Makro-Implementierungen


MX_UINT8 FCD_SWITCH0_ReadState()
{
	
		MX_UINT8 switchval, old_switchval;
	  #if Switch_3_SW_DELAY > 0
		MX_UINT16 del_count = 0;
	  #endif

		FC_CAL_Bit_In_DDR( Switch_3_SW_PORT , Switch_3_SW_TRIS , Switch_3_SW_PIN );
		switchval = FC_CAL_Bit_In( Switch_3_SW_PORT , Switch_3_SW_PIN );			//Convert pin to input
		old_switchval = switchval;

	  #if Switch_3_SW_DELAY > 0
		while (del_count < Switch_3_SW_DELAY)									//Debounce input
		{
			delay_us(1);
			FC_CAL_Bit_In_DDR( Switch_3_SW_PORT , Switch_3_SW_TRIS , Switch_3_SW_PIN );
			switchval = FC_CAL_Bit_In( Switch_3_SW_PORT , Switch_3_SW_PIN );		//Sample input

			if (switchval == old_switchval)								//Is switch the same state?
				del_count = del_count + 1;								//Increment counter
			else
				del_count = 0;											//Else reset counter

			old_switchval = switchval;									//Update the old state
		}
	  #endif

		#if Switch_3_SW_POLE == 0
			if (switchval)												//Invert logic if required
				switchval = 0;
			else
				switchval = 1;
		#endif

		return (switchval);												//Return state of switch as least significant bit

}

void FCD_SWITCH0_WaitUntilHigh()
{
	
		MX_UINT8 switchval, old_switchval;
	  #if Switch_3_SW_DELAY > 0
		MX_UINT16 del_count = 0;
	  #endif

		do
		{
			FC_CAL_Bit_In_DDR ( Switch_3_SW_PORT , Switch_3_SW_TRIS , Switch_3_SW_PIN );
			switchval = FC_CAL_Bit_In ( Switch_3_SW_PORT, Switch_3_SW_PIN );		//Convert pin to input
			old_switchval = switchval;

		  #if Switch_3_SW_DELAY > 0
			while (del_count < Switch_3_SW_DELAY)									//Debounce input
			{
				delay_us(1);
				FC_CAL_Bit_In_DDR ( Switch_3_SW_PORT , Switch_3_SW_TRIS , Switch_3_SW_PIN );
				switchval = FC_CAL_Bit_In ( Switch_3_SW_PORT , Switch_3_SW_PIN );	//Sample input

				if (switchval == old_switchval)								//Is switch the same state?
					del_count = del_count + 1;								//Increment counter
				else
					del_count = 0;											//Else reset counter

				old_switchval = switchval;									//Update the old state
			}
		  #endif

		} while (switchval != Switch_3_SW_POLE);									//While state not active

		#if Switch_3_SW_POLE == 0
			if (switchval)													//Invert logic if required
				switchval = 0;
			else
				switchval = 1;
		#endif

		//return (switchval);												//Return state of switch as least significant bit

}

void FCD_SWITCH0_WaitUntilLow()
{
	
		MX_UINT8 switchval, old_switchval;
	  #if Switch_3_SW_DELAY > 0
		MX_UINT16 del_count = 0;
	  #endif

		do
		{
			FC_CAL_Bit_In_DDR ( Switch_3_SW_PORT, Switch_3_SW_TRIS , Switch_3_SW_PIN );
			switchval = FC_CAL_Bit_In ( Switch_3_SW_PORT, Switch_3_SW_PIN );			//Convert pin to input
			old_switchval = switchval;

		  #if Switch_3_SW_DELAY > 0
			while (del_count < Switch_3_SW_DELAY)									//Debounce input
			{
				delay_us(1);
				FC_CAL_Bit_In_DDR ( Switch_3_SW_PORT, Switch_3_SW_TRIS , Switch_3_SW_PIN );
				switchval = FC_CAL_Bit_In ( Switch_3_SW_PORT, Switch_3_SW_PIN );		//Sample input

				if (switchval == old_switchval)								//Is switch the same state?
					del_count = del_count + 1;								//Increment counter
				else
					del_count = 0;											//Else reset counter

				old_switchval = switchval;									//Update the old state
			}
		  #endif

		} while (switchval == Switch_3_SW_POLE);									//While state active

		#if Switch_3_SW_POLE == 0
			if (switchval)													//Invert logic if required
				switchval = 0;
			else
				switchval = 1;
		#endif

		//return (switchval);												//Return state of switch as least significant bit

}



//EEPROM(0): //Makro-Implementierungen


MX_UINT16 FCD_EEPROM0_EEPROMRead(MX_UINT16 addr)
{
	
		return (FC_CAL_EE_Read (addr));

}

void FCD_EEPROM0_WriteEEPROM(MX_UINT16 addr, MX_UINT16 data)
{
	
		FC_CAL_EE_Write (addr, data);

}

#include "C:\Programme\Flowcode\v5\CAL\includes.c"

//Makro-Implementierungen


void FCM_INIT()
{

	//Output
	//Output: 1 -> A0
	trisio = trisio & 0xFE;
	if ((1))
		gpio = (gpio & 0xFE) | 0x01;
	else
		gpio = gpio & 0xFE;

	//Output
	//Output: 1 -> A1
	trisio = trisio & 0xFD;
	if ((1))
		gpio = (gpio & 0xFD) | 0x02;
	else
		gpio = gpio & 0xFD;

	//Output
	//Output: 1 -> A4
	trisio = trisio & 0xEF;
	if ((1))
		gpio = (gpio & 0xEF) | 0x10;
	else
		gpio = gpio & 0xEF;

	//Output
	//Output: 1 -> A5
	trisio = trisio & 0xDF;
	if ((1))
		gpio = (gpio & 0xDF) | 0x20;
	else
		gpio = gpio & 0xDF;

}



void main()
{
	//Initialisierung
	ansel = 0x20;
cmcon = 0x07;


	//Interrupt-Initialisierungs-Code
	option_reg = 0xC0;


	//Makro-Aufruf
	//Makro-Aufruf: INIT()
	FCM_INIT();

	//Schleife
	//Schleife: While 1
	while (1)
	{

		//Input
		//Input: A3 -> SW1
		trisio = trisio | 0x08;
		FCV_SW1 = ((gpio & 0x08) == 0x08);

		//Entscheidung
		//Entscheidung: SW1?
		if (FCV_SW1)
		{

		} else {

			//Input
			//Input: A0 -> LED1
			trisio = trisio | 0x01;
			FCV_LED1 = ((gpio & 0x01) == 0x01);

			//Entscheidung
			//Entscheidung: LED1?
			if (FCV_LED1)
			{

				//Berechnung
				//Berechnung:
				//  EEprom = 0
				FCV_EEPROM = 0;

				//Output
				//Output: 0 -> PORTA
				trisio = 0x00;
				gpio = (0);

				//Output
				//Output: 1 -> A1
				trisio = trisio & 0xFD;
				if ((1))
					gpio = (gpio & 0xFD) | 0x02;
				else
					gpio = gpio & 0xFD;

				//Aufruf Komponenten-Makro
				//Aufruf Komponenten-Makro: Write(0, EEprom)
				FCD_EEPROM0_WriteEEPROM(0, FCV_EEPROM);

				//Output
				//Output: EEprom -> A5
				trisio = trisio & 0xDF;
				if ((FCV_EEPROM))
					gpio = (gpio & 0xDF) | 0x20;
				else
					gpio = gpio & 0xDF;

				//Aufruf Komponenten-Makro
				//Aufruf Komponenten-Makro: WartenBisLow()
				FCD_SWITCH0_WaitUntilLow();

			} else {

				//Berechnung
				//Berechnung:
				//  EEprom = 1
				FCV_EEPROM = 1;

				//Aufruf Komponenten-Makro
				//Aufruf Komponenten-Makro: Write(0, EEprom)
				FCD_EEPROM0_WriteEEPROM(0, FCV_EEPROM);

				//Output
				//Output: 1 -> PORTA
				trisio = 0x00;
				gpio = (1);

				//Output
				//Output: 0 -> A1
				trisio = trisio & 0xFD;
				if ((0))
					gpio = (gpio & 0xFD) | 0x02;
				else
					gpio = gpio & 0xFD;

				//Aufruf Komponenten-Makro
				//Aufruf Komponenten-Makro: EEprom=Read(0)
				FCV_EEPROM = FCD_EEPROM0_EEPROMRead(0);

				//Output
				//Output: EEprom -> A5
				trisio = trisio & 0xDF;
				if ((FCV_EEPROM))
					gpio = (gpio & 0xDF) | 0x20;
				else
					gpio = gpio & 0xDF;

				//Aufruf Komponenten-Makro
				//Aufruf Komponenten-Makro: WartenBisLow()
				FCD_SWITCH0_WaitUntilLow();

			}

		}


	}

	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
}



